<template>
	<v-row class="search-box" align="center" no-gutters>
		<v-col :cols="option.labelCols" class="py-0">
			<label for="" class="search-box-label">
				<v-icon
					v-if="iconShow"
					small
					:class="['mr-1', required ? 'icon-orange' : 'icon-blue']"
					>$icoBulletPoint</v-icon
				>
				{{ option.labelContent }}
			</label>
		</v-col>
		<v-col :cols="option.textCols">
			<v-text-field :readonly="item.readonly || false" v-model="selectValue" append-icon=""
				class="v-input__custom" @click="dialogOpenCloseEvent(dialog)" outlined :hide-details="true"
				:required="item.required || false" :disabled="item.disabled || false"><template v-slot:append>
					<!-- Custom SVG icon -->
					<v-icon>$icoSearch</v-icon>


				</template></v-text-field>
		</v-col>
		<v-dialog v-model="dialog" scrollable width="800px">
			<v-card style="height: 100%">
				<v-card-title class="px-6 py-4 d-flex align-center justify-space-between">
					<span class="custom-title-4">{{ option.modalTitle }}</span>
					<a-button icon="close" type="text" @click="dialogOpenCloseEvent(dialog)"></a-button>

				</v-card-title>
				<div class="pa-6 pt-0">
					<v-row align="center">
						<v-col :cols="12" class="py-0">
							<label for="" class="search-box-label">
								<v-icon small :class="['mr-1 icon-blue']">$icoBulletPoint</v-icon>
								계산설명
							</label>
						</v-col>
						<v-col :cols="11" class="pr-8 py-0" >
							<v-text-field append-icon="" class="v-input__custom" outlined
								:hide-details="true" v-model="searchWord" @keyup.enter="search"><template v-slot:append>
					<!-- Custom SVG icon -->
					<v-icon>$icoSearch</v-icon>


				</template></v-text-field>
						</v-col>
						<v-col cols="1" class="py-0" style="display: flex; justify-content: flex-end;">
							<a-button icon="search" type="primary" @click="search()" class="search-button">조회</a-button>
							<!-- <v-btn :ripple="false" @click="initSearch()">
                초기화
              </v-btn> -->
						</v-col>
					</v-row>
				</div>
				<!-- <v-divider></v-divider> -->
				<div :style="'height: calc(50vh)'">
					<!-- <div :style="{ height: 'calc(100% - 213px)' }"> -->
					<div ref="modalGridParent" class="h100 px-6 py-4">
						<component :is="loadGrid && dialog ? 'Grid' : null" :gridName="grid_01"
							:dataPath="searchParam.modalData2.eqpmCalcPop" :parentPrgmId="parentPrgmId"
							@getRowsData="getRowData" @dblClick="setUpdate($event)" />
					</div>
				</div>
				<v-card-actions class="pa-5 d-flex align-center justify-end">
					<a-button :ripple="false"  @click="dialogOpenCloseEvent(dialog)" class="mr-2">닫기</a-button>
					<a-button :ripple="false" type="primary" @click="setUpdate($event)" >확인</a-button>
				</v-card-actions>
			</v-card>
		</v-dialog>

	</v-row>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import Grid from '~/components/common/Grid';
import Utility from '~/plugins/utility';

export default {
	props: {
		parentPrgmId: {
			type: String,
			require: true,
		},
		labelCols: {
			type: Number,
			require: false,
			default: 4,
		},
		labelContent: {
			type: String,
			require: false,
			default: '이벤트항목',
		},
		textCols: {
			type: Number,
			require: false,
			default: 7,
		},
		modalTitle: {
			type: String,
			require: false,
			default: '이벤트항목',
		},
		modalContent: {
			type: String,
			require: false,
			default: '검색',
		},
		item: {
			type: Object,
			require: false,
		},
		bindingData: {
			type: String,
			require: false,
		},
		openMode: {
			type: String,
			require: false,
		},
		required: {
			type: Boolean,
			require: false,
			default: false,
		},
		iconShow:{
			type:Boolean,
			require:false,
			default:true
		},
		// bindingFlag:{
		//   type:Boolean,
		//   require: false,
		//   default: false
		// }
	},
	components: {
		Grid,
		Utility,
	},
	data() {
		return {
			dialog: false,

			loadGrid: true,
			dataPathPopExample: {
				"rowGrid": {
					data: [
						{
							'calcProc': 'AVG_CNT2',
							'argCnt': '2',
							'calcDesc': '두개 변수에 대한 평균'

						}
					],
					column: [
						{ header: '계산코드', name: 'calcProc', width: 150 },
						{ header: '아규먼트갯수', name: 'argCnt', align: 'center', width: 100 },
					]
				}
			},
			grid_01: 'grid_01',
			myModalKey: 'eqpmCalcPop',
			modalDataKey: 'modalData2',

			searchWord: '',
			selectedData: {},
			textFieldData: '',

			option: {
				labelCols:
					this.item !== undefined
						? this.item.labelCols !== undefined
							? this.item.labelCols
							: this.labelCols
						: this.labelCols,
				labelContent:
					this.item !== undefined
						? this.item.labelContent !== undefined
							? this.item.labelContent
							: this.labelContent
						: this.labelContent,
				textCols:
					this.item !== undefined
						? this.item.textCols !== undefined
							? this.item.textCols
							: this.textCols
						: this.textCols,
				modalTitle:
					this.item !== undefined
						? this.item.modalTitle !== undefined
							? this.item.modalTitle
							: this.modalTitle
						: this.modalTitle,
			},
		};
	},
	computed: {
		...mapState({
			searchParam(state) {
				return state.pageData[this.parentPrgmId];
			},
			myBindingData(state) {
				if (!this.bindingData) {
					return state.pageData[this.parentPrgmId]['rowGridSelectData'];
				} else {
					return state.pageData[this.parentPrgmId][this.bindingData][
						'rowGridSelectData'
					];
				}
			},
		}),
		selectValue: {
			get() {
				// return this.searchParam[this.item.valueNm];
				if (!this.item) {
					return this.textFieldData;
				}
				// else if(this.item.disableContent){
				//   return "NONE";
				// }
				else {
					return this.myBindingData
						? this.myBindingData[this.item.valueNm]
						: this.textFieldData;
				}
			},
			set(value) {
				// if(this.item && this.item.disableContent){
				//   return "NONE";
				// }
				return value;
			},
		},
	},
	watch: {
		async dialog(val) {
			if (val) {
				await this.getGridData();
			}
		},
	},

	beforeCreate() {
		this.$store.commit('setPageData', {
			modalData2: { eqpmCalcPop },
		});
	},
	async created() {
		this.init();
	},
	mounted() { },
	methods: {
		...mapMutations({
			setPageData: 'setPageData',
			setModalGridData: 'setModalGridData',
			setModalGridColumn: 'setModalGridColumn',
			setModalGridOption: 'setModalGridOption',
		}),
		...mapActions({
			postApiReturn: 'modules/list/postApiReturn',
			setTree: 'modules/list/setTree',
		}),
		init() {
			this.gridInit();
		},
		search() {
			this.getGridData();
		},
		initSearch() {
			this.searchWord = '';
			this.getGridData();
		},
		gridInit() {
			const myOptions = {
				columnOptions: {
					resizable: true,

				},
			};
			this.setModalGridOption({
				modalKey: this.myModalKey,
				gridKey: this.grid_01,
				modalDataKey: this.modalDataKey,
				value: Object.assign(
					// Utility.defaultGridOption(this.$refs.modalGridParent.offsetHeight - 60, myOptions),
					// Utility.defaultGridOption(400, myOptions),
					myOptions,
				),
			});

			this.setModalGridColumn({
				modalKey: this.myModalKey,
				gridKey: this.grid_01,
				modalDataKey: this.modalDataKey,
				value: [
					{ header: '계산코드', name: 'calcProc', width: 150 },
					{ header: '아규먼트갯수', name: 'argCnt', align: 'center', width: 100 },
					{ header: '계산설명', name: 'calcDesc', align: 'left' },
				],
			});
		},
		async getGridData() {
			this.loadGrid = false;
			let res = await this.postApiReturn({
				apiKey: 'selectEqpmCalcPop',
				resKey: 'eqpmCalcPopData',
				sendParam: {
					calcDescLike: this.searchWord,
					openMode: this.item.openMode != undefined ? this.item.openMode : this.openMode
				},
			});
			if (this.myBindingData['calcProc'] != '' || this.myBindingData['calcProc'] != null || this.myBindingData['calcProc'] != undefined) {
				let newRes = [];
				newRes = res.filter(item => {
					return item.calcProc != this.myBindingData['calcProc']
				});
				res = newRes;
			}
			
			this.setModalGridData({
				modalKey: this.myModalKey,
				gridKey: this.grid_01,
				modalDataKey: this.modalDataKey,
				value: res,
			});

			this.loadGrid = true;
		},
		getRowData(data) {
			this.selectedData = { ...data };
		},
		setUpdate(v) {
			this.dialog = false;
			if (!this.item) {
				this.textFieldData = this.selectedData.calcProc;
			} else {
				if (this.item.bindNm) {
					this.myBindingData[this.item.bindNm] = this.selectedData.argCnt;
				} else {
					this.myBindingData.argCnt = this.selectedData.argCnt;
				}
				const dt = {
					columnName: this.item.valueNm,
					value: this.selectedData.calcProc,
				};
				this.$emit('gridEditingFinish', dt);
				this.setPageData({ [this.item.valueNm]: this.selectedData.calcProc });
				if (this.item.valueNm2 !== undefined) {
					const dt = {
						columnName: this.item.valueNm2,
						value: this.selectedData[this.item.valueNm2],
					};
					this.$emit('gridEditingFinish', dt);
					this.setPageData({ [this.item.valueNm2]: this.selectedData.argCnt });
				}
				if (this.item.bindNm !== undefined) {
					const dt = {
						columnName: this.item.bindNm,
						value: this.selectedData.argCnt,
					};
					this.$emit('gridEditingFinish', dt);
					this.setPageData({ [this.item.bindNm]: this.selectedData.argCnt });
				}
			}
		},
		dialogOpenCloseEvent(val) {
			// if(this.item && this.item.disableContent){
			//   this.dialog = false;
			//   return;
			// }
			this.dialog = !val;
		},
	},
};

var eqpmCalcPop = {
	grid_01: {
		data: [],
		column: [],
		option: {},
	},
};
</script>

<style lang="scss" scoped>
::v-deep {
	.v-dialog {
		overflow-y: hidden !important;
	}

	.tui-grid-table-container {
		.tui-grid-table {
			border-right-style: solid !important;
			border-right-color: rgba(255, 255, 255, 0.1) !important;
		}
	}

	.tui-grid-cell.tui-grid-cell-has-tree .tui-grid-tree-extra-content+.tui-grid-cell-content:before {
		content: none !important;
	}

}

</style>
